/* ǡڤġ no.2
 * 08/21 2000
 * shige
 * wavsubstr.c
 *
 * $Id: wavsubstr.c,v 1.3 2000-11-04 00:46:22+09 shige Exp $
 */
/* wavsubstr (-v) (-o file) [start pos] ([length]) [file]
 */

#undef DEBUG1

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "wavio.h"

int getarg(int argc,char **argv,int *start,int *length,int *verbose,
	   FILE **infile,FILE **outfile);
void usage(int ret);

int main(int argc,char *argv[])
{
    WAVdata wd;
    int verbose;
    FILE *infile,*outfile;
    int start,length,totalblocks;
    int ret;
    
    if((ret=getarg(argc,argv,&start,&length,&verbose,&infile,&outfile))<0)
      return -ret;

#ifdef DEBUG1
    printf("verbose=%d\n",verbose);
    printf("start  =%d\n",start);
    printf("length =%d\n",length);
    printf("(infile,outfile)=(%d,%d)\n",fileno(infile),fileno(outfile));
    return 0;
#endif
    /* main routine Ϥ*/
    if(getWAVheader(infile,&wd)<0){
	if(verbose) fprintf(stderr,"Error: In getWAVheader().\n");
	return 20;
    }
    if(wd.fmcode!=1){
	if(verbose)
	  fprintf(stderr,"WAV format is not linear (unsupported).\n");
	return 30;
    }
    totalblocks=wd.datalen/wd.blocksize;
    if(verbose) fprintf(stderr,"total length=%d\n",totalblocks);
    if(start>totalblocks){
	if(verbose){
	    fprintf(stderr,"Error: Too late start position.\n");
	    fprintf(stderr,"It must be less than total length.\n");
	}
	return 0;
    }
    if(length>0 && start+length>totalblocks){
	if(verbose)
	  fprintf(stderr,"Warning: Specified length is too long.\n");
	length=-1;
    }
    if(length<0) length=totalblocks-start;
    wd.datalen=length*wd.blocksize;
    putallWAVheader(outfile,&wd,1);
    putfile2file(infile,outfile,wd.hlen+start*wd.blocksize,wd.datalen);
    return 0;
}

int getarg(int argc,char **argv,int *start,int *length,int *verbose,
	   FILE **infile,FILE **outfile)
{
    char *fname;

    *verbose=0;
    *outfile=stdout;
    *length=-1;

    while(--argc>0){
	if(**(++argv)=='-'){
	    if(*(++*argv)=='v') *verbose=1;
	    else if(**argv=='q') *verbose=0;
	    else if(**argv=='o'){
		if(*outfile!=stdout){ usage(0); return -1; }
		if(*(++*argv)=='\0'){ 
		    if(--argc<=0){ usage(1); return -1; }
		    else argv++;
		}
		fname=*argv;
		if(!strcmp(fname,"-")) *outfile=stdout;
		else if((*outfile=fopen(fname,"w"))==NULL){
		    fprintf(stderr,"File [%s] open error.\n",fname);
		    return -2;
		}
	    }
	    else if(**argv=='h' || **argv=='H' || **argv=='?'){
		usage(2); return -1;
	    }
	    else{ usage(3); return -2; }
	}
	else break;
    }
    if((*start=atoi(*argv))<0){ usage(4); return -3; }
    if(--argc>1){ 
	if((*length=atoi(*(++argv)))<=0){ usage(5); return -4; }
    }
    else argc++;
    if(--argc<=0 || argc>1){ usage(6); return -5; }
    fname=*(++argv);
    if(!strcmp(fname,"-")) *infile=stdin;
    else if((*infile=fopen(fname,"r"))==NULL){
	fprintf(stderr,"File [%s] open error.\n",fname);
	return -6;
    }
    return 0;
}

void usage(int ret)
{
    char *mess[]={
	"Usage: wavsubstr (-v) (-q) (-o [outfile]) [start] ([length]) [infile]",
	"   -v : Ĺ⡼",
	"   -q : quiet ⡼ (default)",
	"   -o [outfile] : ϥեλ (default: ɸ)",
	"   [start] : ϰ",
	"   [length]: ϺĹ (default: Ǹޤ)",
	"   [infile]: ϥե",
	" ",
	" [1] ϥե '-' ꤷɸϤˤʤ롣",
	NULL
    };
    int j;

#ifdef DEBUG1
    printf("USAGE: %d\n",ret);
#endif
    for(j=0;mess[j]!=NULL;j++)
      fprintf(stderr,"%s\n",mess[j]);
}
